import processing.video.*;

// Class Code Set 20



// Modified from Daniel Shiffman's Processing - Chaper 16

// Modified for Processing 2.0

final int MAX = 10;

Capture video;

Square [ ] array;


void setup( )
{
   size( displayWidth, displayHeight );
   String[] cameras = Capture.list();
  
  if (cameras.length == 0) 
  {
    println("There are no cameras available for capture.");
    exit();
  } else 
  {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) 
    {
      println(cameras[i]);
    }
    
    // The camera can be initialized directly using an 
    // element from the array returned by list():
    video = new Capture(this, cameras[0]);
    video.start();  
  }

  
   array = new Square[ MAX ];
   initArray( );
   
   background( 0 );
}

void draw( )
{
   background( 0 );
   moveAndDrawAll( );
}

void moveAndDrawAll( )
{
  for ( int i = 0; i < array.length; i++)
  {
     array[i].move();
     array[i].draw( );
   }  
}

void initArray( )
{
   for ( int i = 0; i < array.length; i++)
  {
     array[i] = new Square( );
     array[i].setup();
   } 
}

void keyPressed( )
{
      initArray( );   
}
