import processing.video.*;

// Class Code Set 20

// Modified from  code by Dan Shiffman and Golan Levin

// Modified for Processing 2.0

// Making a person disappear

/*
   TO RUN
     start program
     step out of camera view
     press any key
     step back into the camera's view
     move the slider bar on the bottom of the window
 
*/
Capture video;

int [ ] previousPixels;
int [ ] backgroundPixels;
int numPixels;
float  diff, threshold;
float average, previousAverage;
int r1, r2, g1, g2, b1, b2;

int  loc;


int sliderX, sliderY, sliderHt, sliderWd, barX, barWd;
void setup()
{
   size( 1280, 720 );
   String[] cameras = Capture.list();
  
  if (cameras.length == 0) 
  {
    println("There are no cameras available for capture.");
    exit();
  }    

    video = new Capture(this, width, height);
    video.start();  
    numPixels = video.width * video.height;
    previousPixels = new int[ numPixels ];
    backgroundPixels = new int [ numPixels ];
    threshold = 0;
    loadPixels( );
    
    rectMode( CENTER );
    noStroke( );
    sliderY = int(height*.95);
    sliderX = width/2;
    sliderWd = int(width*.9);
    sliderHt = 20;
    barX = width/2;
    barWd = 10;
    
    textSize( 18 );
    textAlign( CENTER , CENTER );
}

void draw( )
{ 
  if ( video.available( ) )
  {
        video.read( );
        video.loadPixels( );

        for( int i = 0; i < numPixels; i++)
        {
              color current = video.pixels[i];
              
              
              //print( "C = " + current );
              r1 = (current >> 16) & 0xFF;
              g1 = (current >> 8) & 0xFF;
              b1 = current & 0xFF;
                                       
               float d = dist( r1, g1, b1, r2, g2, b2 );
               if ( abs(d) <= threshold)
               {
                    pixels[i] = backgroundPixels[i];             
               }
               else
                  pixels[i] = current;
        }
        previousPixels = pixels;
        previousAverage = average;
        r2 = r1;
        b2 = b1;
        g2 = g1;
      
       updatePixels( );
    }

  showSlider( ); 
}

void showSlider( )
{
   fill( 200, 200, 0 );
   rect( sliderX, sliderY, sliderWd, sliderHt);
   fill( 0, 0, 200 );
   barX = int( map( threshold, 0, 255, 
               (width/2 - sliderWd/2), (width/2 + sliderWd/2) )  );
   rect( barX, sliderY, barWd, sliderHt ); 
   fill( 0, 0, 255 );
   text( int(threshold), sliderX, sliderY );
   
}
void keyPressed( )
{
   video.loadPixels( );
   arrayCopy( video.pixels, backgroundPixels); 
}

void mouseDragged ( )
{
   threshold = constrain( map( mouseX,(width/2 - sliderWd/2), 
                                      (width/2 + sliderWd/2),
                                      0, 255 ), 0, 255  );
}
