// Class Code Set 21

// From Daniel Shiffman's Processing - Chaper 16

import processing.video.*;
Capture video;

PImage  previousFrame;
PImage moose;

float  diff, threshold;

int  loc;

void setup()
{
   size( 640, 480 );
   video = new Capture( this, width, height, 30 ); 
   previousFrame = createImage( video.width, video.height, RGB );
   
   threshold = 60;
   
   moose = loadImage( "moose.jpg");
   
   textAlign( CENTER, CENTER );
   rectMode( CENTER );
   strokeWeight( 5 );
   stroke( 0 );
}

void draw( )
{  
  background( 255 );
  if( video.available( )  )
  {
     previousFrame.copy( video, 0, 0, video.width, video.height,
                                  0, 0, video.width, video.height );
     previousFrame.updatePixels( );        
     video.read( );
  } 
  loadPixels( );
  video.loadPixels();
  previousFrame.loadPixels( ); 
  
  for( int x = 0; x < video.width; x+=10)
  {
      for( int y = 0; y < video.height; y+=10)
      {
        loc = x + y*video.width;
        color current = video.pixels[loc];
        color previous = previousFrame.pixels[loc];
        
        float r1 = red(current);
        float g1 = green(current);
        float b1 = blue(current);
        float r2 = red(previous);
        float g2 = green(previous);
        float b2 = blue(previous);
      
        diff = dist( r1, g1, b1, r2, g2, b2 );
        
        if ( diff > threshold )
        {
           image( moose, x, y, 20, 20 );
           //point(x, y );
        }
        
      } // end inner for loop
  } // end outer for loop
  
  fill( 200, 200 );
  rect( 50, 50, 50, 20 );
  fill( 0 );
  text( frameRate, 50, 50 );
}


