// use with class note 21
// making someone disappear

// To set this up -- step out of camera range and press any printing key
// This makes a copy of the video that is used to replace the person seen in the camera.
// Now, step back into the frame.
// To disappear, move the slider to the right.
// To re-appear, move the slider to the left.

// When the slider is all the way to the left, what is being shown is the still image
// taken from the video when you pressed the key.  It is not the live video.

import processing.video.*;

Capture video;

PImage backgroundImage;

int sliderX, sliderY, sliderWidth, sliderHeight;
int threshHold;

void setup( )
{
   size( 800, 400 );
 
   video = new Capture( this, 300, 300, 30 );
   
   backgroundImage = createImage(video.width, video.height, RGB);
   frameRate( 30 );
   
   textSize( 20 );
   textAlign(CENTER, CENTER);

   sliderX = 20;
   sliderY = height-50;
   sliderWidth = width - sliderX*2;
   sliderHeight = 20;
   
   threshHold = 255;
   
}

void draw( )
{
    background( 255 );
    //showOriginalImage( );
    
    if( video.available( ) )
    {
       video.read( ); 
    }
    
    modifyAndShowImage( );
    drawSlider( );

    //noLoop( );
}

void modifyAndShowImage( )
{
    video.loadPixels( );
    
    for( int i = 0; i < video.pixels.length; i++)
    {
       color c = video.pixels[i] ;
       float r = red( c );
       float b = blue( c );
       float g = green( c );
       float sum = r + b + g;
       float average = sum/3;
       if (average > threshHold )
       {
         c = color( 0 );
           video.pixels[i] = backgroundImage.pixels[i];
       }
     
       
    }

    image( video, 400, 10, 300, 300);
}

void showOriginalImage( )
{
    image( video, 10, 10, 300, 300);
}

void drawSlider( )
{
   fill( threshHold );
   rectMode(CORNER);
   rect( sliderX, sliderY, sliderWidth, sliderHeight); 
   int barX = int( map( threshHold, 0, 255, sliderX, sliderX+sliderWidth) );
   rectMode(CENTER);
   fill( 255, 0, 0  );
   rect( barX, sliderY+sliderHeight/2, 10, sliderHeight +20 );
   fill( 0 );
   text( threshHold, width/2, sliderY - 25 );
}
void mouseDragged( )
{
   threshHold =  int(constrain( map( mouseX, sliderX, sliderX + sliderWidth, -1, 256 ) , 0, 255) );
   //loop( );
}

void keyPressed( )
{
  backgroundImage.copy( video, 0, 0, video.width, video.height,
                               0, 0, video.width, video.height );
  backgroundImage.updatePixels( );    
}
